use Config;
use File::Basename qw(basename dirname);
chdir(dirname($0));

$perl = shift(@ARGV);

$use = "use lib qw(\n\t" . join("\n\t", @ARGV) . ");\n";

($file = basename($0)) =~ s/\.PL$//;
$file =~ s/\.pl$//
	if ($Config{'osname'} eq 'VMS' or
	    $Config{'osname'} eq 'OS2');  # "case-forgiving"


open OUT,">$file" or die "Can't create $file: $!";
chmod(0755, $file);
print "Extracting $file (with variable substitutions)\n";

print OUT <<"!GROK!THIS!";
#!$perl

#
# Warning: File automatically generated. Any changes made here
# will be lost.
#

$use

##HeaderEnd

!GROK!THIS!
print OUT <<'!NO!SUBS!';




=head1 NAME

list-assets

=head1 SYNOPSIS

list-assets repository-name

=head1 DESCRIPTION

See http://nhse.mcs.anl.gov/NHSE96/RIB/MTk/tools/list-assets.htm
for a full description of this command.

=cut

use strict;

use CGI;
use MTk;

my $CGIBin = $MTk::cgi_bin_url;

eval {
    &main;
};

if ($@)
{
    print "list-assets failed:\n\t$@\n";
    exit(1);
}


exit(0);

sub main
{
    my($db, $repos_name);
    my($query);

    $query = new CGI;

    $repos_name = $query->path_info();
    if (!defined($repos_name))
    {
	$repos_name = "/cool_stuff";
    }
	    
    $repos_name =~ s,^/,,;

    $db = $MTk::DBClass->new();
    $db or die "Cannot connect to database\n";
    
    $db->open();

    my $official = &validate_repository($db, $repos_name);

    print <<END;
Content-type: text/html

<html>
<head>
<title>Asset listing for repository $official</title>
</head>
<body>
<h1>Asset listing for repository $official</h1>
END

    &list_assets($db, $repos_name);

    print <<END;
<form action=\"$CGIBin/show-asset-form-action\" method=\"POST\">

<table>
<tr><td>
<input type=\"hidden\" name=\"repos_name\" value=\"$repos_name\">
</td></tr>
<tr><td>
<input type=\"submit\" name=\"show_create_form\" value=\"Create a new asset\">
</td></tr>
<tr><td>
<input type=\"submit\" name=\"add\"
    value=\"Add an existing asset to the repository\">
</td></tr>
<tr><td>
<input type=\"submit\" name=\"gen_catalog\" value =\"Regenerate catalog\">
</td></tr>
</table>
</form>
END
    my $q = $db->query("select base_url from Repository where name = '$repos_name'");
    my $url = $q->item(0, 0);

    print "<a href=\"$url/toc.html\">Go to the catalog</a>\n";

    print "</body>\n";
    print "</html>\n";
}

#
# Make sure that this is a valid repository.
#

sub validate_repository
{
    my($db, $repos_name) = @_;
    my($q, $official_name);

    $q = $db->query("select official_name from Repository where name = '$repos_name'");
    $q or die "Repository $repos_name not found\n";

    $official_name = $q->item(0, 0);
#    print "Listing assets in repository $official_name\n";
    return $official_name;
}


#
# List the assets...
# 

sub list_assets
{
    my($db, $repos_name) = @_;
    my($q, $asset, $a);
    my($id, $repos, $exp, $last_retr, $qid);

    $q = $db->query("SELECT id FROM Asset where repository = '$repos_name'");

    if ($q)
    {
	print "<UL>\n";
	for $a (@{$q->row_lists})
	{
	    ($id) = @$a;
	    
	    ($qid = $id) =~ s,//,%01,g;
	    print "<LI> <a href=\"$CGIBin/show-asset-form-action/$repos_name/$qid\">$id</a>\n";
#	    $asset = MTk::DBTable::Asset->new($id, $db);
#	    $asset->fetch();
#	    $asset->print();
	    my $ts = new BIDM::Tagset;
#	    $ts->load_from_db($db, $id);
#	    $ts->print();
#	    my $obj = $ts->parse();
#	    if ($obj)
#	    {
#		$obj->walk();
#	    }
	}
	print "</ul>\n";
    }
}

package BIDM::RIGObject;
sub walk
{
    my($self) = @_;
    print "RIG walk $self\n";
}

package BIDM::RIGObject::Asset;
sub walk
{
    my($self) = @_;
    my($name, $k);
    print "Asset walk $self\n";

    print "Domain: ", $self->Domain(), "\n";
    
    for $k ($self->Keyword())
    {
	print "Keyword: $k\n";
    }
    print "Abstract:\n---\n", $self->Abstract(), "\n---\n";
}

package BIDM::RIGObject::Organization;
sub walk
{
    my($self) = @_;
    print "Organization walk $self\n";
}

package BIDM::RIGObject::Library;
sub walk
{
    my($self) = @_;
    print "Library walk $self\n";
}
!NO!SUBS!
